<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "https://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd"><html xmlns="http://www.w3.org/1999/xhtml"><head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<meta name="generator" content="Doxygen 1.8.20"/>
<meta name="viewport" content="width=device-width, initial-scale=1"/>
<a class="dashingAutolink" name="autolink-235"></a><a class="dashAnchor" name="//apple_ref/cpp/Package/XHXKit%3A%20%2FUsers%2Fscar1900%2FDeveloper%2FXHXKit%2FXHXKit%2FClasses%2FGeneral%2FCategory%2FUIView%2BKKLBadgeView.m%20%E6%BA%90%E6%96%87%E4%BB%B6"></a><title>XHXKit: /Users/scar1900/Developer/XHXKit/XHXKit/Classes/General/Category/UIView+KKLBadgeView.m 源文件</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="search/searchdata.js"></script>
<script type="text/javascript" src="search/search.js"></script>
<link href="doxygen.css" rel="stylesheet" type="text/css"/>
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td id="projectalign" style="padding-left: 0.5em;">
   <div id="projectname">XHXKit
   &nbsp;<span id="projectnumber">4.10.0.12</span>
   </div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- 制作者 Doxygen 1.8.20 -->
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
var searchBox = new SearchBox("searchBox", "search",false,'搜索');
/* @license-end */
</script>
<script type="text/javascript" src="menudata.js"></script>
<script type="text/javascript" src="menu.js"></script>
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
$(function() {
  initMenu('',true,false,'search.php','搜索');
  $(document).ready(function() { init_search(); });
});
/* @license-end */</script>
<div id="main-nav"></div>
<!-- window showing the filter options -->
<div id="MSearchSelectWindow" onmouseover="return searchBox.OnSearchSelectShow()" onmouseout="return searchBox.OnSearchSelectHide()" onkeydown="return searchBox.OnSearchSelectKey(event)">
</div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<iframe src="javascript:void(0)" frameborder="0" name="MSearchResults" id="MSearchResults">
</iframe>
</div>

<div id="nav-path" class="navpath">
  <ul>
<li class="navelem"><a class="el" href="dir_d522931ffa1371640980b621734a4381.html">Users</a></li><li class="navelem"><a class="el" href="dir_2f48480e0fdb0436fb8fd57a1ed5f613.html">scar1900</a></li><li class="navelem"><a class="el" href="dir_c8b33409012acfc781ba898892fd3b4c.html">Developer</a></li><li class="navelem"><a class="el" href="dir_0e1030ab80149b7e8d6dfd17946e9c40.html">XHXKit</a></li><li class="navelem"><a class="el" href="dir_c9ece41fcb3917ec137dcec44cd0055f.html">XHXKit</a></li><li class="navelem"><a class="el" href="dir_3a9521ad7c4429598be7e28fa39d3d14.html">Classes</a></li><li class="navelem"><a class="el" href="dir_3d53dd88e59abdcd55a12c7e475393fb.html">General</a></li><li class="navelem"><a class="el" href="dir_6aab43a226a6a6887d476b2e5d48e49d.html">Category</a></li>  </ul>
</div>
</div><!-- top -->
<div class="header">
  <div class="headertitle">
<div class="title">UIView+KKLBadgeView.m</div>  </div>
</div><!--header-->
<div class="contents">
<a href="_u_i_view_09_k_k_l_badge_view_8m.html">浏览该文件的文档.</a><div class="fragment"><div class="line"><a name="l00001"></a><span class="lineno">    1</span>&nbsp;<span class="comment">//</span></div>
<div class="line"><a name="l00002"></a><span class="lineno">    2</span>&nbsp;<span class="comment">//  UIView+KKLBadgeView.m</span></div>
<div class="line"><a name="l00003"></a><span class="lineno">    3</span>&nbsp;<span class="comment">//  KKLOnLine</span></div>
<div class="line"><a name="l00004"></a><span class="lineno">    4</span>&nbsp;<span class="comment">//</span></div>
<div class="line"><a name="l00005"></a><span class="lineno">    5</span>&nbsp;<span class="comment">//  Created by 江俊辰 on 2017/9/20.</span></div>
<div class="line"><a name="l00006"></a><span class="lineno">    6</span>&nbsp;<span class="comment">//  Copyright &copy; 2017年 mistong. All rights reserved.</span></div>
<div class="line"><a name="l00007"></a><span class="lineno">    7</span>&nbsp;<span class="comment">//</span></div>
<div class="line"><a name="l00008"></a><span class="lineno">    8</span>&nbsp; </div>
<div class="line"><a name="l00009"></a><span class="lineno">    9</span>&nbsp;<span class="preprocessor">#import &#34;<a class="code" href="_u_i_view_09_k_k_l_badge_view_8h.html">UIView+KKLBadgeView.h</a>&#34;</span></div>
<div class="line"><a name="l00010"></a><span class="lineno">   10</span>&nbsp;<span class="preprocessor">#import &lt;objc/runtime.h&gt;</span></div>
<div class="line"><a name="l00011"></a><span class="lineno">   11</span>&nbsp;<span class="preprocessor">#import &lt;KKLThirdParty/Masonry.h&gt;</span></div>
<div class="line"><a name="l00012"></a><span class="lineno">   12</span>&nbsp; </div>
<div class="line"><a name="l00013"></a><span class="lineno"><a class="line" href="category_u_i_view_07_k_k_l_badge_view_08.html#a2976a4bb937bde16cae0fc6f4cd78e7a">   13</a></span>&nbsp;<span class="keyword">static</span> <span class="keywordtype">char</span> sBadgeViewKey;</div>
<div class="line"><a name="l00014"></a><span class="lineno">   14</span>&nbsp; </div>
<div class="line"><a name="l00015"></a><span class="lineno">   15</span>&nbsp;<span class="keyword">@implementation </span><a class="code" href="category_u_i_view_07_k_k_l_badge_view_08.html">UIView (KKLBadgeView)</a></div>
<div class="line"><a name="l00016"></a><span class="lineno">   16</span>&nbsp; </div>
<div class="line"><a name="l00017"></a><span class="lineno">   17</span>&nbsp;- (__kindof UIView *)kkl_badgeView {</div>
<div class="line"><a name="l00018"></a><span class="lineno">   18</span>&nbsp;    <span class="keywordflow">return</span> [<span class="keyword">self</span> __badgeView];</div>
<div class="line"><a name="l00019"></a><span class="lineno">   19</span>&nbsp;}</div>
<div class="line"><a name="l00020"></a><span class="lineno">   20</span>&nbsp; </div>
<div class="line"><a name="l00021"></a><span class="lineno">   21</span>&nbsp;- (UIView *)__badgeView {</div>
<div class="line"><a name="l00022"></a><span class="lineno">   22</span>&nbsp;    <span class="keywordflow">return</span> objc_getAssociatedObject(<span class="keyword">self</span>, &amp;sBadgeViewKey);</div>
<div class="line"><a name="l00023"></a><span class="lineno">   23</span>&nbsp;}</div>
<div class="line"><a name="l00024"></a><span class="lineno">   24</span>&nbsp; </div>
<div class="line"><a name="l00025"></a><span class="lineno">   25</span>&nbsp;- (void)__setBadgeView:(UIView *)badgeView {</div>
<div class="line"><a name="l00026"></a><span class="lineno">   26</span>&nbsp;    UIView *oldBadgeView = [<span class="keyword">self</span> __badgeView];</div>
<div class="line"><a name="l00027"></a><span class="lineno">   27</span>&nbsp;    <span class="keywordflow">if</span> (oldBadgeView) {</div>
<div class="line"><a name="l00028"></a><span class="lineno">   28</span>&nbsp;        [oldBadgeView removeFromSuperview];</div>
<div class="line"><a name="l00029"></a><span class="lineno">   29</span>&nbsp;    }</div>
<div class="line"><a name="l00030"></a><span class="lineno">   30</span>&nbsp;    <span class="keywordflow">if</span> (badgeView) {</div>
<div class="line"><a name="l00031"></a><span class="lineno">   31</span>&nbsp;        objc_setAssociatedObject(<span class="keyword">self</span>, &amp;sBadgeViewKey, badgeView, OBJC_ASSOCIATION_RETAIN_NONATOMIC);</div>
<div class="line"><a name="l00032"></a><span class="lineno">   32</span>&nbsp;        [<span class="keyword">self</span> addSubview:badgeView];</div>
<div class="line"><a name="l00033"></a><span class="lineno">   33</span>&nbsp;    }</div>
<div class="line"><a name="l00034"></a><span class="lineno">   34</span>&nbsp;}</div>
<div class="line"><a name="l00035"></a><span class="lineno">   35</span>&nbsp; </div>
<div class="line"><a name="l00036"></a><span class="lineno">   36</span>&nbsp;- (void)removeCurrentBadgeView {</div>
<div class="line"><a name="l00037"></a><span class="lineno">   37</span>&nbsp;    [<span class="keyword">self</span> __setBadgeView:nil];</div>
<div class="line"><a name="l00038"></a><span class="lineno">   38</span>&nbsp;    </div>
<div class="line"><a name="l00039"></a><span class="lineno">   39</span>&nbsp;}</div>
<div class="line"><a name="l00040"></a><span class="lineno">   40</span>&nbsp; </div>
<div class="line"><a name="l00041"></a><span class="lineno">   41</span>&nbsp;- (void)setBadgeView:(UIView *)badgeView size:(CGSize)size alignment:(KKLBadgeViewAlignment)alignment insets:(UIEdgeInsets)insets {</div>
<div class="line"><a name="l00042"></a><span class="lineno">   42</span>&nbsp;    [<span class="keyword">self</span> __setBadgeView:badgeView];</div>
<div class="line"><a name="l00043"></a><span class="lineno">   43</span>&nbsp;    [badgeView mas_makeConstraints:^(MASConstraintMaker *make) {</div>
<div class="line"><a name="l00044"></a><span class="lineno">   44</span>&nbsp;        make.size.mas_equalTo(size);</div>
<div class="line"><a name="l00045"></a><span class="lineno">   45</span>&nbsp;        if (alignment == KKLBadgeViewAlignmentLeftTop) {</div>
<div class="line"><a name="l00046"></a><span class="lineno">   46</span>&nbsp;            make.top.equalTo(self).offset(insets.top);</div>
<div class="line"><a name="l00047"></a><span class="lineno">   47</span>&nbsp;            make.left.equalTo(self).offset(insets.left);</div>
<div class="line"><a name="l00048"></a><span class="lineno">   48</span>&nbsp;        } else if (alignment == KKLBadgeViewAlignmentRightTop) {</div>
<div class="line"><a name="l00049"></a><span class="lineno">   49</span>&nbsp;            make.top.equalTo(self).offset(insets.top);</div>
<div class="line"><a name="l00050"></a><span class="lineno">   50</span>&nbsp;            make.right.equalTo(self).offset(-insets.right);</div>
<div class="line"><a name="l00051"></a><span class="lineno">   51</span>&nbsp;        } else if (alignment == KKLBadgeViewAlignmentLeftBottom) {</div>
<div class="line"><a name="l00052"></a><span class="lineno">   52</span>&nbsp;            make.top.equalTo(self).offset(insets.left);</div>
<div class="line"><a name="l00053"></a><span class="lineno">   53</span>&nbsp;            make.right.equalTo(self).offset(-insets.bottom);</div>
<div class="line"><a name="l00054"></a><span class="lineno">   54</span>&nbsp;        }</div>
<div class="line"><a name="l00055"></a><span class="lineno">   55</span>&nbsp;    }];</div>
<div class="line"><a name="l00056"></a><span class="lineno">   56</span>&nbsp;}</div>
<div class="line"><a name="l00057"></a><span class="lineno">   57</span>&nbsp; </div>
<div class="line"><a name="l00058"></a><span class="lineno">   58</span>&nbsp;<span class="keyword">@end</span></div>
</div><!-- fragment --></div><!-- contents -->
<div class="ttc" id="a_u_i_view_09_k_k_l_badge_view_8h_html"><div class="ttname"><a href="_u_i_view_09_k_k_l_badge_view_8h.html">UIView+KKLBadgeView.h</a></div></div>
<div class="ttc" id="acategory_u_i_view_07_k_k_l_badge_view_08_html"><div class="ttname"><a href="category_u_i_view_07_k_k_l_badge_view_08.html">UIView(KKLBadgeView)</a></div><div class="ttdef"><b>Definition:</b> <a href="_u_i_view_09_k_k_l_badge_view_8h_source.html#l00018">UIView+KKLBadgeView.h:18</a></div></div>
<!-- start footer part -->
<hr class="footer"/><address class="footer"><small>
制作者&nbsp;<a href="http://www.doxygen.org/index.html"><img class="footer" src="doxygen.svg" width="104" height="31" alt="doxygen"/></a> 1.8.20
</small></address>


</body></html>